<template>
	<!-- pc -->
	<div>
		<div class="news-main" v-if="userStore.isPcorH">
			<div class="newstablist flex">
				<div
					class="newstablists"
					:class="{
						activetab: item.value == active,
					}"
					v-for="item in tab"
					:key="item.value"
					@click="changeTab(item.value)">
					{{ item.title }}
				</div>
			</div>

			<div v-loading="loading">
				<div
					data-aos="flip-down"
					:class="userStore.isPcorH ? 'nodate' : 'nodateh5'"
					v-if="list.length == 0 && !loading">
					暂无数据
				</div>
				<div v-if="userStore.isPcorH">
					<div
						class="list allwidth"
						data-aos="flip-down"
						v-for="item2 in list"
						@click="godetail(item2)"
						:key="item2.id">
						<div class="lists">
							<el-image
								fit="cover"
								class="lists_img"
								:src="item2.images"
								v-if="item2.images">
							</el-image>
							<div class="lists_demo">
								<p class="lists_demo_title">
									{{ item2.title }}
								</p>
								<div
									class="lists_demo_content"
									v-html="item2.content2"></div>
								<div class="lists_demo_btn">
									<div class="time">
										{{
											formatTime(
												new Date(
													item2.created_at * 1000
												)
											)
										}}
									</div>
									<div class="detail">
										查看详情
										<el-icon
											style="position: relative; top: 2px"
											><DArrowRight
										/></el-icon>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="pages">
					<el-pagination
						size="small"
						:layout="'prev, pager, next'"
						background
						@current-change="handleSizeChange"
						v-model:current-page="pageparms.page"
						v-model:page-size="pageparms.size"
						:total="pageparms.total"
						class="mt-4" />
				</div>
			</div>
		</div>
		<div class="news-mainh5" v-if="!userStore.isPcorH">
			<div class="newstablist flex">
				<div
					class="newstablists"
					:class="{
						activetab: item.value == active,
					}"
					v-for="item in tab"
					:key="item.value"
					@click="changeTab(item.value)">
					{{ item.title }}
				</div>
			</div>

			<div v-loading="loading">
				<div
					data-aos="flip-down"
					:class="userStore.isPcorH ? 'nodate' : 'nodateh5'"
					v-if="list.length == 0 && !loading">
					暂无数据
				</div>
				<div>
					<div
						data-aos="flip-down"
						class="list allwidth"
						v-for="item2 in list"
						@click="godetail(item2)"
						:key="item2.id">
						<div class="lists">
							<el-image
								fit="cover"
								class="lists_img"
								:src="item2.images"
								v-if="item2.images">
							</el-image>
							<div class="lists_demo">
								<p class="lists_demo_title">
									{{ item2.title }}
								</p>
								<div
									class="lists_demo_content"
									v-html="item2.content2"
									:style="
										'width:' + item2.images
											? '80%;'
											: '100%;'
									"></div>
								<p class="lists_demo_btn">
									<span class="time">{{
										formatTime(
											new Date(item2.created_at * 1000)
										)
									}}</span>
									<span class="detail"
										>查看详情
										<el-icon
											style="position: relative; top: 2px"
											><DArrowRight /></el-icon
									></span>
								</p>
							</div>
						</div>
					</div>
				</div>
				<div class="pages" data-aos="fade-up">
					<el-pagination
						size="small"
						:layout="'prev, pager, next'"
						background
						@current-change="handleSizeChange"
						v-model:current-page="pageparms.page"
						v-model:page-size="pageparms.size"
						:total="pageparms.total"
						class="mt-4" />
				</div>
			</div>
		</div>
	</div>
</template>

<script setup>
import { useI18n } from "vue-i18n";
import { ref, watch } from "vue";
import { useAsyncData } from "#app";
import { geturl, formatTime } from "@/utils/index.js";
import useUserStore from "~/store/index";
import { DArrowRight } from "@element-plus/icons-vue";
const userStore = useUserStore();
const router = useRouter();
const { t } = useI18n();
const url = geturl();
const active = ref("");
const userinfo = computed(() => {
	return userStore.info;
});
const loading = ref(false);
const pageparms = ref({
	page: 1,
	size: 10,
	total: 0,
});
const handleSizeChange = val => {
	pageparms.value.page = val;
	getnewslist();
};
const tab = ref([]);
const gettypelist = async () => {
	loading.value = true;
	let data = await $fetch(`${url}/api/news/class`);
	data.message.forEach(e => {
		e.content2 = e.content ? replaceImagesWithText(e.content) : e.content;
	});
	pageparms.value.total = data.count;
	tab.value = [
		{ title: "全部", value: "" },
		...(data.message.map(e => ({
			title: e.name,
			value: e.id,
		})) || []),
	];

	getnewslist();
};
const godetail = item => {
	localStorage.setItem("newsDetail", JSON.stringify(item));
	localStorage.setItem(
		"newsPage",
		JSON.stringify({
			...pageparms.value,
			active: active.value,
		})
	);
	router.push({
		path: "/newsDetail",
	});
};

const list = ref([]);

const getnewslist = async () => {
	loading.value = true;
	let listdata = await $fetch(
		`${url}/api/news/list?class_id=${active.value}&page=${pageparms.value.page}&size=${pageparms.value.size}`
	);
	listdata.message.forEach(e => {
		e.content2 = e.content ? replaceImagesWithText(e.content) : e.content;
	});
	pageparms.value.total = listdata.count;
	list.value = listdata.message;

	loading.value = false;
};

const changeTab = value => {
	active.value = value;
	getnewslist();
};

function replaceImagesWithText(html) {
	// 创建一个临时的 div 元素来解析 HTML
	const tempDiv = document.createElement("div");
	tempDiv.innerHTML = html;

	// 查找所有图片标签并替换为 <图片>
	const images = tempDiv.getElementsByTagName("img");

	for (let i = 0; i < images.length; i++) {
		const img = images[i];
		// 替换图片为 <图片>
		const textNode = document.createTextNode("");
		img.parentNode.replaceChild(textNode, img);
	}

	// 返回替换后的 HTML
	return tempDiv.innerHTML;
}
onMounted(() => {
	let newsPage = localStorage.getItem("newsPage");
	if (newsPage) {
		let newsPages = JSON.parse(newsPage);
		pageparms.value.page = newsPages?.page || 1;
		active.value = newsPages?.active || "";
		localStorage.removeItem("newsPage");
	}
	gettypelist();
});
</script>

<style lang="scss" scoped>
// pc
.news-main {
	width: 100%;
	.newstablist {
		display: flex;
		gap: 50px;
		font-size: 16px;
		width: 100%;
		border-bottom: 1px solid #aeaeae;
		padding: 0 20%;
		margin-top: 60px;
		flex-wrap: wrap;
		.newstablists {
			cursor: pointer;
			padding: 0 20px 20px 20px;
			position: relative;
			top: 1px;
			&:hover {
				color: #46bfe5;
				border-bottom: 3px solid #46bfe5;
			}
		}
		.newstablistsh5 {
			display: grid;
			grid-template-columns: repeat(5, 1fr);
			// display: flex;
			text-align: center;
			font-size: 0.32rem;
			gap: 0.1rem;
			justify-content: center;
			margin-top: 15px;
			margin-bottom: 15px;
		}
	}
	.list {
		.lists {
			overflow: hidden;
			cursor: pointer;
			margin-top: 20px;
			display: flex;
			height: 250px;
			padding: 30px;
			box-shadow: 0 2px 18px rgba(0, 0, 0, 0.1);
			.lists_img {
				width: 30%;
				margin-right: 60px;
			}
			.lists_demo {
				flex: 1;
				display: flex;
				flex-direction: column;
				gap: 20px;
				box-sizing: border-box;
				padding: 30px 0;
				overflow: hidden;
				.lists_demo_title {
					font-size: 20px;
				}
				.lists_demo_content {
					display: -webkit-box;
					-webkit-line-clamp: 2; /* 显示两行 */
					-webkit-box-orient: vertical;
					overflow: hidden;
					text-overflow: ellipsis;
					color: #aeaeae;
				}
				.lists_demo_btn {
					color: #aeaeae;
					display: flex;
					margin-top: auto;
					.time {
						flex: 1;
					}
				}
			}
			&:hover {
				.detail {
					color: #46bfe5;
				}
				.lists_demo_title {
					color: #46bfe5;
				}
			}
		}
	}
}
// h5
.news-mainh5 {
	width: 100vw;
	padding: 0 15px;
	box-sizing: border-box;
	margin-top: 25px;
	overflow: hidden;
	.newstablist {
		display: grid;
		grid-template-columns: repeat(5, 1fr);
		// display: flex;
		text-align: center;
		font-size: 0.38rem;
		gap: 0.1rem;
		justify-content: center;
		margin-bottom: 15px;
		line-height: 0.8rem;
	}
	.list {
		width: 100%;
		.lists {
			width: 100%;
			cursor: pointer;
			margin-top: 20px;
			display: flex;
			height: 2.4rem;
			box-sizing: border-box;
			overflow: hidden;
			padding: 0.3rem;
			box-shadow: 0 2px 18px rgba(0, 0, 0, 0.1);
			.lists_img {
				width: 30%;
				min-width: 30%;
				max-width: 30%;
				height: 100%;
				overflow: hidden;
				margin-right: 0.3rem;
			}
			.lists_demo {
				flex: 1;
				display: flex;
				flex-direction: column;
				gap: 0.1rem;

				padding: 0.1rem 0;
				box-sizing: border-box;
				display: flex;
				overflow: hidden;
				.lists_demo_title {
					font-size: 0.32rem;
				}
				.lists_demo_content {
					font-size: 0.32rem;
					white-space: nowrap; /* 禁止换行 */
					overflow: hidden; /* 隐藏溢出内容 */
					text-overflow: ellipsis; /* 超出用省略号表示 */
					flex: 1;
					overflow: hidden;
					color: #aeaeae;
				}
				.lists_demo_btn {
					font-size: 0.32rem;
					color: #aeaeae;
					display: flex;
					margin-top: auto;
					width: 100%;

					.time {
						flex: 1;
					}
				}
			}
			&:hover {
				.detail {
					color: #46bfe5;
				}
				.lists_demo_title {
					color: #46bfe5;
				}
			}
		}
	}
}
.activetab {
	color: #46bfe5;
	border-bottom: 3px solid #46bfe5;
}
.nodate {
	text-align: center;
	line-height: 100px;
	color: #666666;
	font-size: 18px;
}
.nodateh5 {
	text-align: center;
	line-height: 50px;
	color: #666666;
	font-size: 0.38rem;
}
.pages {
	width: 100%;
	display: flex;
	align-items: center;
	justify-content: center;
	margin-top: 20px;
}
</style>
